
#ifndef CONTIRADARCONVERTER_CFG_H_
#define CONTIRADARCONVERTER_CFG_H_ 1

#ifdef __cplusplus
extern "C" {
#endif

/*==================[macros]================================================*/

/** New Sensor model */
/** Position X */
#define  TUEOBJLIST_RAD_SENSOR_MODEL_POS_X_BETA_0     (0.95110f)
#define  TUEOBJLIST_RAD_SENSOR_MODEL_POS_X_BETA_1     (-0.0247f)
#define  TUEOBJLIST_RAD_SENSOR_MODEL_POS_X_BETA_2     (FLT_ZERO)
#define  TUEOBJLIST_RAD_SENSOR_MODEL_POS_X_BETA_3     (0.00020f)
#define  TUEOBJLIST_RAD_SENSOR_MODEL_POS_X_BETA_4     (0.00450f)
#define  TUEOBJLIST_RAD_SENSOR_MODEL_POS_X_BETA_5     (FLT_ZERO)
#define  TUEOBJLIST_RAD_SENSOR_MODEL_POS_X_MIN        (0.1500f)
#define  TUEOBJLIST_RAD_SENSOR_MODEL_POS_X_MAX        (FLT_ONE)

/* Position Y */
#define  TUEOBJLIST_RAD_SENSOR_MODEL_POS_Y_BETA_0     (0.3242f)
#define  TUEOBJLIST_RAD_SENSOR_MODEL_POS_Y_BETA_1     (-0.0028f)
#define  TUEOBJLIST_RAD_SENSOR_MODEL_POS_Y_BETA_2     (FLT_ZERO)
#define  TUEOBJLIST_RAD_SENSOR_MODEL_POS_Y_BETA_3     (0.0001f)
#define  TUEOBJLIST_RAD_SENSOR_MODEL_POS_Y_BETA_4     (0.0060f)
#define  TUEOBJLIST_RAD_SENSOR_MODEL_POS_Y_BETA_5     (FLT_ZERO)
#define  TUEOBJLIST_RAD_SENSOR_MODEL_POS_Y_MIN        (TUEOBJLIST_RAD_SENSOR_MODEL_POS_Y_BETA_0)
#define  TUEOBJLIST_RAD_SENSOR_MODEL_POS_Y_MAX        (3.16230f)

/** Velocity X */
#define  TUEOBJLIST_RAD_SENSOR_MODEL_VEL_X_BETA_0     (1.5791f)
#define  TUEOBJLIST_RAD_SENSOR_MODEL_VEL_X_BETA_1     (-0.0305f)
#define  TUEOBJLIST_RAD_SENSOR_MODEL_VEL_X_BETA_2     (FLT_ZERO)
#define  TUEOBJLIST_RAD_SENSOR_MODEL_VEL_X_BETA_3     (0.0002f)
#define  TUEOBJLIST_RAD_SENSOR_MODEL_VEL_X_BETA_4     (0.0003f)
#define  TUEOBJLIST_RAD_SENSOR_MODEL_VEL_X_BETA_5     (FLT_ZERO)
#define  TUEOBJLIST_RAD_SENSOR_MODEL_VEL_X_MIN        (0.057f)
#define  TUEOBJLIST_RAD_SENSOR_MODEL_VEL_X_MAX        (FLT_TWO)

/** Velocity Y */
#define  TUEOBJLIST_RAD_SENSOR_MODEL_VEL_Y_BETA_0     (1.87190f)
#define  TUEOBJLIST_RAD_SENSOR_MODEL_VEL_Y_BETA_1     (0.04293f)
#define  TUEOBJLIST_RAD_SENSOR_MODEL_VEL_Y_BETA_2     (FLT_ZERO)
#define  TUEOBJLIST_RAD_SENSOR_MODEL_VEL_Y_BETA_3     (0.00000f)
#define  TUEOBJLIST_RAD_SENSOR_MODEL_VEL_Y_BETA_4     (0.00270f)
#define  TUEOBJLIST_RAD_SENSOR_MODEL_VEL_Y_BETA_5     (FLT_ZERO)
#define  TUEOBJLIST_RAD_SENSOR_MODEL_VEL_Y_MIN        (TUEOBJLIST_RAD_SENSOR_MODEL_VEL_Y_BETA_0)
#define  TUEOBJLIST_RAD_SENSOR_MODEL_VEL_Y_MAX        (4.25230f)

/** Acceleration X */
#define  TUEOBJLIST_RAD_SENSOR_MODEL_ACC_X_BETA_0     (FLT_TWO)
#define  TUEOBJLIST_RAD_SENSOR_MODEL_ACC_X_BETA_1     (-0.0356f)
#define  TUEOBJLIST_RAD_SENSOR_MODEL_ACC_X_BETA_2     (FLT_ZERO)
#define  TUEOBJLIST_RAD_SENSOR_MODEL_ACC_X_BETA_3     (0.00030f)
#define  TUEOBJLIST_RAD_SENSOR_MODEL_ACC_X_BETA_4     (0.00970f)
#define  TUEOBJLIST_RAD_SENSOR_MODEL_ACC_X_BETA_5     (FLT_ZERO)
#define  TUEOBJLIST_RAD_SENSOR_MODEL_ACC_X_MIN        (0.75f)
#define  TUEOBJLIST_RAD_SENSOR_MODEL_ACC_X_MAX        (FLT_TWO) 

#define  TUEOBJLIST_RAD_SENSOR_DEFAULT_CLASS_PROB     (99u)

#define  TUEOBJLIST_RAD_LATENCY_TO_SECONDS            (1000.0f)
#define  TUEOBJLIST_RADAR_DEFAULT_LATENCY_SECONDS     (0.02f)

#define  TUEOBJLIST_RAD_USE_ACCELERATION              (STD_ON)

/* define for object existence probability threshold */
#define TUEOBJLIST_RAD_EXIST_PROB_THRESHOLD           (95.f)

/* define bit pattern if object is ASIL verified */
#define TUEOBJLIST_RAD_BITPATTERN_ASIL_VALID          (0x0Fu)
#define TUEOBJLIST_RAD_BITPATTERN_ASIL_INVALID        (0x00u)
  
/** 
  * If enabled, road boundary detection algorithm is active such that 
  * stationary radar tracks that can be clustered to a line parallel to the
  * ego vehicle are removed 
  */
#define  TUEOBJLIST_RAD_ENABLE_ROAD_BOUNDARY_DETECTION               (STD_OFF)

//life cycle threshold for camera object confirmed in last seted cycles.
//if fusion output object has been updated by camera in last 50 cycles, 
//then this object is set CamConfirmed to TRUE
#define TUE_CAMERA_CONFIRMED_LIFECYCLE_THRESHOLD (10)
#if STD_ON == TUEOBJLIST_RAD_ENABLE_ROAD_BOUNDARY_DETECTION

/* Limit yaw-rate of ego-vehicle to approximately 11 deg / s */
#define TUEOBJLIST_RAD_ROAD_BOUNDARY_DETECTION_MAX_YAW               (11.f)

/** Max distance used in clustering during road boundary detection, set to 2.5m squared */
#define TUEOBJLIST_RAD_ROAD_BOUNDARY_DETECTION_MAX_DIST               (7.f)

#define TUEOBJLIST_RAD_ROAD_BOUNDARY_DETECTION_DIST_WEIGHT_X          (0.60f)

#define TUEOBJLIST_RAD_ROAD_BOUNDARY_DETECTION_DIST_WEIGHT_Y          (1.75f)

/* Minimum number of neighbors in order to create a cluster */
#define TUEOBJLIST_RAD_ROAD_BOUNDARY_DETECTION_MIN_NUM_NEIGHBORS      (2u)

/* Minimum number of elements per cluster to do linear regression */
#define TUEOBJLIST_RAD_ROAD_BOUNDARY_DETECTION_MIN_TRACKS_PER_CLUSTER (4u)

#define TUEOBJLIST_RAD_ROAD_BOUNDARY_DETECTION_MAX_RADAR_TRACKS       (40u)

#define TUEOBJLIST_RAD_ROAD_BOUNDARY_DETECTION_OFFSET_X               (3.0f)

#define TUEOBJLIST_RAD_ROAD_BOUNDARY_DETECTION_OFFSET_Y               (2.0f)

#define TUEOBJLIST_RAD_ROAD_BOUNDARY_DETECTION_LENGTH                 (40.0f)

#define TUEOBJLIST_RAD_ROAD_BOUNDARY_DETECTION_WIDTH                  (6.0f)

#define TUEOBJLIST_RAD_ROAD_BOUNDARY_DETECTION_MAX_NUM_CLUSTERS       (10u)

#define TUEOBJLIST_RAD_ROAD_BOUNDARY_DETECTION_MAX_SLOPE              ((0.4f * TUEOBJLIST_RAD_ROAD_BOUNDARY_DETECTION_WIDTH) / TUEOBJLIST_RAD_ROAD_BOUNDARY_DETECTION_LENGTH)

#define TUEOBJLIST_RAD_ROAD_BOUNDARY_DETECTION_MAX_DIST_TO_LINE       (0.25f)

#endif

/*==================[function]====================================*/

/*==================[external constants]====================================*/

#ifdef __cplusplus
}
#endif

#endif /* MPFRADAROBJLISTTOOBJFUSNOBJLISTCONVERT_H_ */
